<?php
/**
 * montonio/module-shipping
 *
 * @category   montonio
 * @package    module-shipping
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */

namespace Montonio\Shipping\Api\Data;

interface ShippingPointsInterface
{
    /**#@+
     * Constants for keys of data array. Identical to the name of the getter in snake case
     */
    public const UUID                   = 'uuid';
    public const SHIPPING_CODE         = 'shipping_code';
    public const NAME                  = 'name';
    public const REGION                = 'region';
    public const LOCALITY              = 'locality';
    /**#@-*/

    /**
     * Get Shipping Code
     *
     * @return string|null
     */
    public function getShippingCode();

    /**
     * Get Name
     *
     * @return string|null
     */
    public function getName();

    /**
     * Get Region
     *
     * @return string|null
     */
    public function getRegion();

    /**
     * Get Locality
     *
     * @return string|null
     */
    public function getLocality();

    /**
     * Get UUID
     *
     * @return string|null
     */
    public function getUuid();

    /**
     * Set Shipping code
     *
     * @param string $shippingCode
     * @return $this
     */
    public function setShippingCode(string $shippingCode);

    /**
     * Set Title
     *
     * @param string $name
     * @return $this
     */
    public function setName(string $name);

    /**
     * Set Region
     *
     * @param string $region
     * @return $this
     */
    public function setRegion(string $region);

    /**
     * Set Locality
     *
     * @param string $locality
     * @return $this
     */
    public function setLocality(string $locality);

    /**
     * Set UUID
     *
     * @param string $uuid
     * @return $this
     */
    public function setUuid($uuid);
}
