<?php
/**
 * montonio/module-shipping
 *
 * @category   montonio
 * @package    module-shipping
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */

namespace Montonio\Shipping\Gateway\Export;

use Magento\Sales\Api\Data\ShipmentInterface;
use Montonio\Shipping\Gateway\Shippings\MontonioSDK;

class PrintLabel
{

    /**
     * @var MontonioSDK
     */
    protected $montonioSDK;

    /**
     * @param MontonioSDK $montonioSDK
     */
    public function __construct(
        MontonioSDK $montonioSDK
    ) {
        $this->montonioSDK = $montonioSDK;
    }

    /**
     * Print Labels
     *
     * @param ShipmentInterface $shipment
     * @return mixed
     */
    public function printLabel(ShipmentInterface $shipment)
    {
        $merchantReference = $shipment->getOrder()->getIncrementId() . '_' . $shipment->getIncrementId();
        $data = [
            'merchant_references' => [$merchantReference]
        ];

        return $this->montonioSDK->createLabels($data);
    }
}
