<?php
/**
 * montonio/module-shipping
 *
 * @category   montonio
 * @package    module-shipping
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */

namespace Montonio\Shipping\Model\Shipping;

use Magento\Checkout\Model\ConfigProviderInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Montonio\Shipping\Gateway\Shippings\Config\Config;

/**
 * Class ShippingConfigProvider for providing config for Shipping
 */
class ShippingsConfigProvider implements ConfigProviderInterface
{
    /**
     *
     * @var string
     */
    public const CODE = 'montonio_shipping';

    /**
     * Default sort order for method row.
     */
    public const DEFAULT_SORT_ORDER = 50;
    /**
     * @var Config
     */
    protected $config;
    /**
     * @var ScopeConfigInterface
     */
    protected $scopeConfig;

    /**
     *
     * @param Config $config
     * @param ScopeConfigInterface $scopeConfig
     */
    public function __construct(
        Config $config,
        ScopeConfigInterface $scopeConfig
    ) {
        $this->config = $config;
        $this->scopeConfig = $scopeConfig;
    }

    /**
     * Retrieve assoc array of checkout configuration
     *
     * @return array
     */
    public function getConfig()
    {
        return $this->config->getConfig();
    }

    /**
     * Retrieve config object
     *
     * @return Config
     */
    public function getConfigObject()
    {
        return $this->config;
    }
}
