/**
 * montonio/module-shipping
 *
 * @category   montonio
 * @package    module-shipping
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */
define(
    [
        "mage/translate",
        "Magento_Ui/js/model/messageList",
        "Magento_Checkout/js/model/quote",
        "underscore"
    ],
    function (
        $t,
        messageList,
        quote,
        _
    ) {
        "use strict";
        return {
            validate: function () {
                let isValid = true; //Put your validation logic here

                let method = quote.shippingMethod();

                //false
                //if method
                //if method is ours
                //if requires a pickup location
                //if location is not set in billing address

                if (
                    !quote.isVirtual() &&
                    !_.isNull(method) &&
                    (
                        !_.isUndefined(method.carrier_code) &&
                        !_.isUndefined(method.method_code) &&
                        method.carrier_code === "montonio_shipping" &&
                        method.method_code.indexOf('courier', 0) === -1
                    )
                ) {
                    let address;

                    if(!_.isNull(quote.shippingAddress()) && _.isNull(quote.billingAddress())) {
                        address = quote.shippingAddress();
                    } else {
                        address = quote.billingAddress();
                    }

                    if(
                        _.isUndefined(address.extension_attributes)
                    ) {
                        isValid = false;
                    }

                    if(
                        !_.isUndefined(address.extension_attributes) &&
                        _.isUndefined(address.extension_attributes.montonio_shipping_point)
                    ) {
                        isValid = false;
                    }

                }
                if (!isValid) {
                    messageList.addErrorMessage({ message: $t("Please pick the location for shipping method %s .").replace('%s', method.method_title) });
                }

                return isValid;
            }
        }
    }
);